<template>
  <div
    class="service-status"
    :class="{
      '--large': this.isLarge,
      '--alert': dataByStatus.icon === 'alert'
    }"
  >
    <div
      class="service-status__row"
      :class="{
        '--alert': dataByStatus.icon === 'alert'
      }"
    >
      <img
        v-if="dataByStatus.icon"
        :src="require('../icons/' + dataByStatus.icon + '.svg')"
      />
      <span class="status">{{ dataByStatus.title }}</span>
      <div
        v-if="dataByStatus.isParticipant"
        class="participant"
      >
        {{ participantTitle }}
      </div>
      <span
        v-if="['APPROVED', 'DECLINED'].includes(status)"
        class="status-date"
      >
        от {{ service.updatedAt | date('DD.MM.YYYY HH:mm') }}
      </span>
    </div>
    <div
      v-if="dataByCrossCharged"
      class="service-status__row --cross-charged"
      :class="{
        '--alert': dataByCrossCharged.icon === 'alert'
      }"
    >
      <img
        v-if="dataByCrossCharged.icon"
        :src="require('../icons/' + dataByCrossCharged.icon + '.svg')"
      />
      <span class="status">{{ dataByCrossCharged.title }}</span>
      <div
        v-if="dataByCrossCharged.isParticipant"
        class="participant"
      >
        {{ participantTitle }}
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  name: 'orderAdditionalServicesListStatus',
  props: {
    service: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
    isLarge: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    ...mapGetters({
      participantUuid: 'user/participantUuid',
      isClicar: 'user/isClicar',
      firstOrder: 'order/order',
    }),
    status () {
      return this.service.status
    },
    isCorrection () {
      return this.service?.serviceKind === 'CORRECTION'
    },
    isAdditionalService () {
      return this.service?.serviceKind === 'ADDITIONAL_SERVICE'
    },
    isCreator () {
      return this.service.creatorUuid === this.participantUuid
    },
    isDeclinedSelf () {
      return this.service.acceptorUuid === this.participantUuid
    },
    crossCharged () {
      return this.service.crossCharged
    },
    participantTitle () {
      return this.service.creatorUuid === this.order.clientUuid ? this.order.contractorTitle : this.order.clientTitle
    },
    declinedTitle () {
      if (this.isCreator) {
        return this.isDeclinedSelf ? 'Отменено вами' : 'Отклонено'
      } else {
        return this.isDeclinedSelf ? 'Отклонено вами' : ''
      }
    },
    dataByStatus () {
      const titleMap = {
        NEW: {
          title: this.isCreator ? 'Ожидание подтверждения от' : 'К подтверждению',
          icon: this.isCreator ? 'clock' : 'alert',
          isParticipant: this.isCreator
        },
        APPROVED: {
          title: this.isCreator ? 'Подтверждено' : 'Подтверждено вами',
          icon: 'accepted'
        },
        DECLINED: {
          title: this.declinedTitle,
          icon: 'cancelled',
          isParticipant: !this.isDeclinedSelf
        }
      }

      return titleMap[this.status] ? titleMap[this.status] : {}
    },
    dataByCrossCharged () {
      if (!this.order.isSuborder || !this.isClicar || !this.isAdditionalService) return null

      const isCrossChargeBlock = ['INVOICING', 'INVOICED', 'PAY_PROCESS', 'PAID', 'FAILED', 'CANCELED'].includes(this.firstOrder.status)

      if (isCrossChargeBlock && this.crossCharged === 'TO_CROSS_CHARGE') return null

      const titleMap = {
        TO_CROSS_CHARGE: {
          title: 'К перевыставлению',
          icon: 'alert'
        },
        DECLINED: {
          title: 'Перевыставление отклонено',
          icon: 'cancelled'
        }
      }

      return titleMap[this.crossCharged] ? titleMap[this.crossCharged] : {
        title: 'Перевыставлено',
        icon: 'accepted'
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.service-status {
  &__row {
    display: flex;
    align-items: center;
    @include font-mixin(10px, 20px, 400, $color-grey-label, 0.4px, uppercase);
    img, i {
      margin-right: 8px;
    }
    &.--alert {
      color: $diamond-orange-yellow;
    }
    .status, .participant {
      flex-shrink: 0;
    }
    .participant {
      margin-left: 4px;
      color: $color-blue-navy-blue;
    }
    .status-date {
      margin-left: 4px;
      white-space: nowrap;
    }
  }
  &.--large {
    .service-status__row {
      @include font-mixin(16px, 20px, 400, $color-grey-label, 0.4px);
      img, i {
        width: 25px;
        font-size: 25px;
        margin-right: 15px;
      }
    }
  }
}
</style>
